package com.neusoft.cwff.javacode;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import org.eclipse.jface.operation.IRunnableWithProgress;

import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;
import org.eclipse.ui.wizards.newresource.BasicNewResourceWizard;


import org.eclipse.jdt.internal.ui.util.ExceptionHandler;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.JavaModelException;

import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;
import org.eclipse.ui.wizards.newresource.BasicNewResourceWizard;

/**
 * @author wyz
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class JavaCodeCreationWizard extends BasicNewResourceWizard implements INewWizard 
{
	private static JavaCodeCreationWizardPage fPage;
	public JavaCodeCreationWizard()
	{
		setNeedsProgressMonitor(true);
		setDefaultPageImageDescriptor(JavaCodePlugin.getDefault().getImageDescriptor("book.gif"));
		setDialogSettings(JavaCodePlugin.getDefault().getDialogSettings());
		setWindowTitle("new"); 
	}
	
	public void addPages() 
	{
		super.addPages();
		fPage= new JavaCodeCreationWizardPage();
		addPage(fPage);
		fPage.init(getSelection());
	}
	
	public boolean performFinish() 
	{
		if (finishPage(fPage.getRunnable())) 
		{
			ICompilationUnit cu= fPage.getCreatedType().getCompilationUnit();
			if (cu.isWorkingCopy()) {
				cu= (ICompilationUnit)cu.getOriginalElement();
			}	
			try {
				IResource resource= cu.getUnderlyingResource();
				selectAndReveal(resource);
				openResource(resource);
			} catch (JavaModelException e) {
//				JavaCodePlugin.log(e);
				// let pass, only reveal and open will fail
			}
			return true;
		}
		return false;			
	}
	
	protected boolean finishPage(IRunnableWithProgress runnable) {
		IRunnableWithProgress op= new WorkspaceModifyDelegatingOperation(runnable);
		try {
			getContainer().run(false, true, op);
		} catch (InvocationTargetException e) {
			Shell shell= getShell();
			String title="New";
			String message= "Creation of element failed.";
			ExceptionHandler.handle(e, shell, title, message);
			return false;
		} catch  (InterruptedException e) {
			return false;
		}
		return true;
	}	
	
	
	protected void openResource(final IResource resource) {
		if (resource.getType() == IResource.FILE) {
			final IWorkbenchPage activePage= JavaCodePlugin.getDefault().getActivePage();
			if (activePage != null) { 
				final Display display= getShell().getDisplay();
				if (display != null) {
					display.asyncExec(new Runnable() {
						public void run() {
							try {
								activePage.openEditor((IFile)resource);
							} catch (PartInitException e) {
//								JavaCodePlugin.log(e);
							}
						}
					});
				}
			}
		}
	}
}
