package com.neusoft.cwff.javacode;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;
import org.eclipse.core.runtime.Status;

//import org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitDocumentProvider;
import org.eclipse.jdt.ui.IWorkingCopyManager;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.plugin.AbstractUIPlugin;

/**
 * @author wyz
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class JavaCodePlugin extends AbstractUIPlugin{
	private static JavaCodePlugin fJavaCodePlugin;
//	private CompilationUnitDocumentProvider fCompilationUnitDocumentProvider;	
	private ResourceBundle resourceBundle;
	
	public static JavaCodePlugin getDefault() {
		return fJavaCodePlugin;
	}
	
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}
		
	public JavaCodePlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		fJavaCodePlugin= this;
//		try {
//			resourceBundle= ResourceBundle.getBundle("examples_javaviewer");
//		} catch (MissingResourceException x) {
//			resourceBundle = null;
//		}
	}
	
//	public IWorkingCopyManager getWorkingCopyManager() {
//		return getCompilationUnitDocumentProvider();
//	}
//	
//	public CompilationUnitDocumentProvider getCompilationUnitDocumentProvider() {
//		if (fCompilationUnitDocumentProvider == null)
//			fCompilationUnitDocumentProvider= new CompilationUnitDocumentProvider();
//		return fCompilationUnitDocumentProvider;
//	}
//	
	public  static ImageDescriptor getImageDescriptor(String name) {
		String iconPath = "icons/";
		try {
			URL installURL = getDefault().getDescriptor().getInstallURL();
			URL url = new URL(installURL, iconPath + name);
			return ImageDescriptor.createFromURL(url);

		} catch (MalformedURLException e) {
			// should not happen
			return ImageDescriptor.getMissingImageDescriptor();
		}
	}
	
	public static String getResourceString(String key) {
		ResourceBundle bundle= JavaCodePlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}	
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
	
	public static void log(IStatus status) {
		getDefault().getLog().log(status);
	}
		
	public static String getPluginId() 
	{
		return getDefault().getDescriptor().getUniqueIdentifier();
	}
	
	//	public static void logErrorMessage(String message) {
//		log(new Status(IStatus.ERROR, getPluginId(), JavaStatusConstants.INTERNAL_ERROR, message, null));
//	}
//
//	public static void logErrorStatus(String message, IStatus status) {
//		if (status == null) {
//			logErrorMessage(message);
//			return;
//		}
//		MultiStatus multi= new MultiStatus(getPluginId(), JavaStatusConstants.INTERNAL_ERROR, message, null);
//		multi.add(status);
//		log(multi);
//	}
//	
//	public static void log(Throwable e) {
//		log(new Status(IStatus.ERROR, getPluginId(), "er","Internal Error", e)); //$NON-NLS-1$
//	}
	public static IWorkbenchPage getActivePage() {
		return getDefault().internalGetActivePage();
	}
	private IWorkbenchPage internalGetActivePage() {
		IWorkbenchWindow window= getWorkbench().getActiveWorkbenchWindow();
		if (window == null)
			return null;
		return getWorkbench().getActiveWorkbenchWindow().getActivePage();
	}
}
